import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Hashtable;

class ImagePanel extends JPanel {
    Image image;

    int sx=0;
    int sy=0;

    public ImagePanel(Image image) {
        this.image = image;
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g); //paint background

        //Draw image at its natural size first.
        g.drawImage(image, sx, sy, this); //85x62 image
    }

    public void paintAlge(int x,int y) { 
        sx=x;
 	sy=y;
 	repaint();
    }
} 

class AboutDlg extends JFrame {
	
}

public class algen extends JFrame implements ActionListener
{
	JMenuBar grayMenuBar;
	JToolBar toolBar;
	JPanel toolPanel;
       	ImagePanel aqua;
	JLabel statusLabel;
	
	GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
         	
	String[] Test={"sdf","hgff","gfhCV"};

	JComboBox AlgList = new JComboBox(Test);
        
        Timer timer;
        int x=0;
        int y=0;

	int SimulationDelay=50;
        boolean Running = false; 
                          	
        ImageIcon OpenRolloverImg=new ImageIcon("images/OpenImgOver.gif");
        ImageIcon SaveRolloverImg=new ImageIcon("images/SaveImgOver.gif");
        ImageIcon OpenImg=new ImageIcon("images/OpenImg.gif");
        ImageIcon SaveImg=new ImageIcon("images/SaveImg.gif");

        JSlider SpeedSlider;
        JSlider LightSlider;
 
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        Image AlgUp=toolkit.getImage("images/al_up.gif");
        Image AlgDown=toolkit.getImage("images/al_down.gif");
        Image AlgLeft=toolkit.getImage("images/al_left.gif");
        Image AlgRight=toolkit.getImage("images/al_right.gif");
       
        JMenu SimulationMenu = new JMenu("Simulation");
        JMenuItem NewMenuItem = new JMenuItem("New Simulation",KeyEvent.VK_N);
        JMenuItem OpenMenuItem=new JMenuItem("Open Simulation",KeyEvent.VK_O);
           	
        JMenuItem SaveAsMenuItem=new JMenuItem("Save as...",KeyEvent.VK_A);
       	JMenuItem SaveMenuItem=new JMenuItem("Save",KeyEvent.VK_S);
      	JMenuItem QuitMenuItem=new JMenuItem("Quit ALGAE",KeyEvent.VK_Q);
        
     	JMenu WindowMenu=new JMenu("Windows");
       	JMenuItem InfoItem = new JMenuItem("Info window", KeyEvent.VK_I);
        JMenu HelpMenu=new JMenu("Help");
       	JMenuItem HelpTopicsMenuItem = new JMenuItem("Topics", KeyEvent.VK_T);
        JMenuItem HelpAboutMenuItem=new JMenuItem("About ALGAE", KeyEvent.VK_A);
	
        JButton NewButton=new JButton(new ImageIcon("images/NewImg.gif"));
        JButton OpenButton=new JButton(OpenImg);                
        JButton SaveButton=new JButton(SaveImg);
        JButton PlayButton=new JButton(new ImageIcon("images/PlayImg.gif"));
	JButton PauseButton=new JButton(new ImageIcon("images/PauseImg.gif"));
        JButton StepButton=new JButton(new ImageIcon("images/StepImg.gif"));
        JButton ResetButton=new JButton(new ImageIcon("images/ResetImg.gif"));
        JButton HelpButton=new JButton(new ImageIcon("images/HelpImg.gif"));
  	JButton ZoomInButton=new JButton(new ImageIcon("images/ZoomIn.gif"));
  	JButton ZoomOutButton=new JButton(new ImageIcon("images/ZoomOut.gif"));

	JCheckBox NoDisplayCB=new JCheckBox("Display ON/OFF");
  	JCheckBox DayNightCB=new JCheckBox("Day/Night cycle");
	
  	public void AddMenuItems()
        {
        	// add Simulation menu
		SimulationMenu.setMnemonic(KeyEvent.VK_S);
          	grayMenuBar.add(SimulationMenu);
          	
          	// items of the Simulation menu
          	SimulationMenu.add(NewMenuItem);
		NewMenuItem.addActionListener(this);
          	SimulationMenu.add(OpenMenuItem);
	
		SimulationMenu.add(SaveAsMenuItem);
          	SimulationMenu.add(SaveMenuItem);
          	SimulationMenu.addSeparator();
          	SimulationMenu.add(QuitMenuItem);         
		QuitMenuItem.addActionListener(this);
		
		// add windows menu
		WindowMenu.setMnemonic(KeyEvent.VK_W);
		grayMenuBar.add(WindowMenu);
		
		// add items for windows menu
		WindowMenu.addSeparator();
          	WindowMenu.add(InfoItem);         
		
		// add Help menu
		HelpMenu.setMnemonic(KeyEvent.VK_H);
		grayMenuBar.add(HelpMenu);
			
		// items of the Help menu
          	HelpMenu.add(HelpTopicsMenuItem); 
          	HelpMenu.addSeparator();
		HelpMenu.add(HelpAboutMenuItem);          	                  
        }	

        public void actionPerformed(ActionEvent e)
        {
	    Object src=e.getSource();
	    if (src==QuitMenuItem)
		{
		    //Custom button text
		    Object[] options = {"Yes","No",};
                    int result = JOptionPane.showOptionDialog(this,
                        "Do you really like to quit ALGAE ? ",
                        "Confirmation",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,
                        options,
                        options[1]);
		    if (result==JOptionPane.YES_OPTION)
			System.exit(0);		
		}
	    if ((src==PlayButton) && (!Running))
	    {
	    	System.out.println("Play button pressed...");
	    	Running=true;
	    	timer.start();
	    }
	    if ((src==PauseButton) && (Running))
	    {
	    	System.out.println("Pause button pressed...");
	    	Running=false;
	    	timer.stop();
	    }
	    if ((src==StepButton) && (!Running))
	    {
	    	System.out.println("Step-Button button pressed...");
	    }
	}
                 
        public void AddToolBarButtons()
        {
        	NewButton.setToolTipText("Start new simulation");
        	toolBar.add(NewButton);

                OpenButton.setPressedIcon(OpenRolloverImg);
                OpenButton.setRolloverIcon(OpenRolloverImg);
                OpenButton.setRolloverEnabled(true);
                OpenButton.setToolTipText("Open a simulation file");
        	toolBar.add(OpenButton);

                SaveButton.setPressedIcon(SaveRolloverImg);
                SaveButton.setRolloverIcon(SaveRolloverImg);
                SaveButton.setRolloverEnabled(true);
        	SaveButton.setToolTipText("Save current simulation file");
        	toolBar.add(SaveButton);
        	
        	toolBar.addSeparator();
	
		PlayButton.addActionListener(this);
         	PlayButton.setToolTipText("Start/continue simulation");
        	toolBar.add(PlayButton);
         	PauseButton.addActionListener(this);
        	PauseButton.setToolTipText("Pause simulation");
        	toolBar.add(PauseButton);
        	StepButton.addActionListener(this);
        	StepButton.setToolTipText("Simulate single step");
        	toolBar.add(StepButton);
        	ResetButton.addActionListener(this);
        	ResetButton.setToolTipText("Reset simulation");
        	toolBar.add(ResetButton);
        	
        	toolBar.addSeparator();
        	/*
        	HelpButton.setToolTipText("Open online help");
        	toolBar.add(HelpButton);
                toolBar.addSeparator();
                */
        	ZoomInButton.setToolTipText("Zoom in aquarium view");
        	toolBar.add(ZoomInButton);
                ZoomOutButton.setToolTipText("Zoom out aquarium view");
        	toolBar.add(ZoomOutButton);
                toolBar.addSeparator();
      	}

        public void AddSliders()
        {
                SpeedSlider = new JSlider(JSlider.HORIZONTAL,0, 50, SimulationDelay);
		SpeedSlider.addChangeListener(new SliderListener());
		SpeedSlider.setMajorTickSpacing(25);
		SpeedSlider.setMinorTickSpacing(10);
		SpeedSlider.setPaintTicks(true);
		SpeedSlider.setPaintLabels(true);

		JLabel SpeedLabel = new JLabel("Simulation Speed", JLabel.CENTER);
        	SpeedLabel.setAlignmentX(Component.CENTER_ALIGNMENT);

		Hashtable SpeedLabelTable = new Hashtable();
          	SpeedLabelTable.put( new Integer( 0 ), new JLabel("Fast") );
          	SpeedLabelTable.put( new Integer( 50 ), new JLabel("Slow") );
          	SpeedSlider.setLabelTable(SpeedLabelTable);
          	SpeedSlider.setBorder(BorderFactory.createEmptyBorder(0,0,10,0));
                
                c.gridx = 0;
         	c.gridy = 5;
         	c.gridwidth=4;
         	c.gridheight=5;
         	c.weightx=1;
         	c.weighty=1;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
         	gridbag.setConstraints(SpeedSlider, c);
         	getContentPane().add(SpeedSlider);		
						
                LightSlider = new JSlider(JSlider.HORIZONTAL,0, 100, 100);
		//LightSlider.addChangeListener(new SliderListener());
		LightSlider.setMajorTickSpacing(50);
		LightSlider.setMinorTickSpacing(20);
		LightSlider.setPaintTicks(true);
		LightSlider.setPaintLabels(true);
		
		//Create the label table
          	Hashtable LightLabelTable = new Hashtable();
          	LightLabelTable.put( new Integer( 0 ), new JLabel("Dark") );
          	LightLabelTable.put( new Integer( 100 ), new JLabel("Bright") );
          	LightSlider.setLabelTable( LightLabelTable );
				
		LightSlider.setBorder(BorderFactory.createEmptyBorder(0,0,10,0));
                
                c.gridx = 4;
         	c.gridy = 4;
         	c.gridwidth=4;
         	c.gridheight=4;
         	c.weightx=1;
         	c.weighty=1;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
         	gridbag.setConstraints(LightSlider, c);
         	getContentPane().add(LightSlider);		
        }
        
        public void AddCBS()
        {
        	// add "toggle display" checkbox
        	c.gridx = 12;
         	c.gridy = 1;
         	c.gridwidth=1;
         	c.gridheight=1;
         	c.weightx=1;
         	c.weighty=1;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
         	gridbag.setConstraints(NoDisplayCB, c);
         	getContentPane().add(NoDisplayCB);
         	
         	// add "day night cycle" checkbox
        	c.gridx = 12;
         	c.gridy = 3;
         	c.gridwidth=1;
         	c.gridheight=1;
         	c.weightx=1;
         	c.weighty=1;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
         	gridbag.setConstraints(DayNightCB, c);
         	getContentPane().add(DayNightCB);        	
        }
        
        public void AddAlgaeCombo()
        {	// add "algae" combobox
        	c.gridx = 5;
         	c.gridy = 2;
         	c.gridwidth=1;
         	c.gridheight=1;
         	c.weightx=1;
         	c.weighty=1;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.HORIZONTAL;
         	gridbag.setConstraints(AlgList, c);
         	getContentPane().add(AlgList);        	
         	
        }
        
        public void AddToolBar()
        {
		toolBar = new JToolBar();
		toolBar.setFloatable(false);
				
		// toolbar on top of content pane
         	c.gridx = 0;
         	c.gridy = 0;
         	c.gridwidth=4;
         	c.gridheight=5;
         	c.weightx=1;
         	c.weighty=1;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
         	gridbag.setConstraints(toolBar, c);
         	getContentPane().add(toolBar);
      	}

        public void AddCanvas()
        {
        	aqua = new ImagePanel(AlgUp);
         	aqua.setBackground(Color.white);
          	aqua.setPreferredSize(new Dimension(500, 500));
          	
		JScrollPane scrollPane = new JScrollPane(aqua);
                scrollPane.setPreferredSize(new Dimension(400, 400));
                
                c.gridx = 0;
         	c.gridy = 10;
         	c.gridwidth=14;
         	c.gridheight=10;
         	c.weightx=1;
         	c.weighty=1;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
         	gridbag.setConstraints(scrollPane, c);
         	getContentPane().add(scrollPane);          	
        }
        
        public void AddStatusBar()
        {
        	statusLabel=new JLabel("Ready to start simulation...");
        	
        	c.gridx = 0;
         	c.gridy = 20;
         	c.gridwidth=12;
         	c.gridheight=1;
         	c.weightx=1;
         	c.weighty=1;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
         	gridbag.setConstraints(statusLabel, c);
         	getContentPane().add(statusLabel);          	        	
        }
        
        public void SetupGUI()
        {
        	// assign gridbag-layout to contentpane
        	getContentPane().setLayout(gridbag);
        	        	
        	// add main menu items
        	AddMenuItems();
        	// add toolbar to top of contentpane
        	AddToolBar();
        	AddToolBarButtons();
        	
        	/*
        	toolPanel=new JPanel();
		toolPanel.setLayout(new BorderLayout());
		toolBar.add(toolPanel);
		*/
		//AddAlgaeCombo();
		AddSliders();
		AddCBS();
		
        	AddCanvas();
        	AddStatusBar();
        }
		
	public algen() 
	{
        	addWindowListener(new WindowAdapter() 
        		{
            			public void windowClosing(WindowEvent e) 
            			{
        				//Custom button text
		    			System.exit(0);		
            			}
        		});

        	grayMenuBar = new JMenuBar();
        	grayMenuBar.setOpaque(true);
        	grayMenuBar.setPreferredSize(new Dimension(200, 20));

		SetupGUI();

		timer = new Timer(SimulationDelay*10, new ActionListener() {
		    public void actionPerformed(ActionEvent evt) {
			x++;
			y++;
			aqua.paintAlge(x,y); 
		    }    
		});
		
        	setJMenuBar(grayMenuBar);
        	timer.setCoalesce(false);
		
        }

        public static void main(String s[])
	{
	        algen window = new algen();
		window.setTitle("ALGAE Simulation");
		window.setResizable(false);
		window.setSize(800,600);
		window.setVisible(true);
        }
       
        class SliderListener implements ChangeListener {
	    public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)e.getSource();
		if (/*(!source.getValueIsAdjusting()) &&*/
		    (source==SpeedSlider))
		{
		    int fps=(int)source.getValue();
		    SimulationDelay=fps;		    
 		    timer.setDelay(fps*10);
 		    System.out.println("SimulationDelay="+SimulationDelay);		
		}
	    }
	}
       

}

